package dev.shadowsoffire.apotheosis.adventure.client;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import java.util.List;
import net.minecraft.client.gui.GuiGraphics;
import net.minecraft.client.gui.components.AbstractWidget;
import net.minecraft.client.gui.narration.NarrationElementOutput;
import net.minecraft.network.chat.Component;
import net.minecraft.util.Mth;

public abstract class DropDownList<T> extends AbstractWidget {
  public static final int NO_SELECTION = -1;
  
  protected final int maxDisplayedEntries;
  
  protected final int baseHeight;
  
  protected List<T> entries;
  
  protected float scrollOffs;
  
  protected boolean scrolling;
  
  protected int startIndex;
  
  protected boolean isOpen = false;
  
  protected int selected = -1;
  
  public DropDownList(int x, int y, int width, int height, Component narrationMsg, List<T> entries, int maxDisplayedEntries) {
    super(x, y, width, height, narrationMsg);
    this.entries = entries;
    this.maxDisplayedEntries = maxDisplayedEntries;
    this.baseHeight = height;
  }
  
  protected void m_87963_(GuiGraphics gfx, int mouseX, int mouseY, float partialTick) {
    int selected = getSelected();
    if (selected != -1)
      renderEntry(gfx, m_252754_(), m_252907_(), mouseX, mouseY, this.entries.get(selected)); 
    if (this.isOpen)
      for (int i = this.startIndex; i < this.startIndex + this.maxDisplayedEntries && i < this.entries.size(); i++)
        renderEntry(gfx, m_252754_(), m_252907_() + this.baseHeight * (1 + i - this.startIndex), mouseX, mouseY, this.entries.get(i));  
  }
  
  public void m_5716_(double mouseX, double mouseY) {
    if (!this.isOpen) {
      if (this.entries.isEmpty())
        return; 
      this.isOpen = true;
      this.f_93619_ = this.baseHeight * (1 + Math.min(this.entries.size(), this.maxDisplayedEntries));
    } else {
      this.selected = getHoveredSlot(mouseX, mouseY);
      this.f_93619_ = this.baseHeight;
      this.isOpen = false;
    } 
  }
  
  public static boolean isHovering(int x, int y, int width, int height, double mouseX, double mouseY) {
    return (mouseX >= x && mouseY >= y && mouseX < (x + width) && mouseY < (y + height));
  }
  
  public int getHoveredSlot(double mouseX, double mouseY) {
    if (isHovering(m_252754_(), m_252907_(), this.f_93618_, this.baseHeight, mouseX, mouseY))
      return getSelected(); 
    if (this.isOpen)
      for (int i = 0; i < this.maxDisplayedEntries; i++) {
        if (this.startIndex + i < this.entries.size() && 
          isHovering(m_252754_(), m_252907_() + (i + 1) * this.baseHeight, this.f_93618_, this.baseHeight, mouseX, mouseY))
          return this.startIndex + i; 
      }  
    return -1;
  }
  
  public boolean m_7979_(double pMouseX, double pMouseY, int pButton, double pDragX, double pDragY) {
    if (this.scrolling && isScrollBarActive()) {
      int barTop = m_252754_() + 14;
      int barBot = barTop + 103;
      this.scrollOffs = ((float)pMouseY - barTop - 6.0F) / ((barBot - barTop) - 12.0F) - 0.12F;
      this.scrollOffs = Mth.m_14036_(this.scrollOffs, 0.0F, 1.0F);
      this.startIndex = (int)((this.scrollOffs * getOffscreenRows()) + 0.5D);
      return true;
    } 
    return super.m_7979_(pMouseX, pMouseY, pButton, pDragX, pDragY);
  }
  
  public boolean m_6050_(double pMouseX, double pMouseY, double pDelta) {
    if (isScrollBarActive()) {
      int i = getOffscreenRows();
      this.scrollOffs = (float)(this.scrollOffs - pDelta / i);
      this.scrollOffs = Mth.m_14036_(this.scrollOffs, 0.0F, 1.0F);
      this.startIndex = (int)((this.scrollOffs * i) + 0.5D);
    } 
    return true;
  }
  
  private boolean isScrollBarActive() {
    return (isOpen() && this.entries.size() > this.maxDisplayedEntries);
  }
  
  protected int getOffscreenRows() {
    return this.entries.size() - this.maxDisplayedEntries;
  }
  
  public int getSelected() {
    return Mth.m_14045_(this.selected, -1, this.entries.size() - 1);
  }
  
  public void setSelected(int selected) {
    this.selected = Mth.m_14045_(selected, -1, this.entries.size() - 1);
  }
  
  public boolean isOpen() {
    return this.isOpen;
  }
  
  protected abstract void renderEntry(GuiGraphics paramGuiGraphics, int paramInt1, int paramInt2, int paramInt3, int paramInt4, T paramT);
  
  protected void m_168797_(NarrationElementOutput output) {}
  
  public void setEntries(List<T> entries) {
    this.entries = entries;
    this.selected = this.entries.isEmpty() ? -1 : 0;
    this.f_93619_ = this.baseHeight;
    this.startIndex = 0;
    this.isOpen = false;
  }
}
